P2879 [USACO07JAN]区间统计Tallest Cow

6 篇文章 0 订阅
3 篇文章 0 订阅

题目描述

FJ's N (1 ≤ N ≤ 10,000) cows conveniently indexed 1..N are standing in a line. Each cow has a positive integer height (which is a bit of secret). You are told only the height H (1 ≤ H ≤ 1,000,000) of the tallest cow along with the index I of that cow.

FJ has made a list of R (0 ≤ R ≤ 10,000) lines of the form "cow 17 sees cow 34". This means that cow 34 is at least as tall as cow 17, and that every cow between 17 and 34 has a height that is strictly smaller than that of cow 17.

For each cow from 1..N, determine its maximum possible height, such that all of the information given is still correct. It is guaranteed that it is possible to satisfy all the constraints.

输入格式

Line 1: Four space-separated integers: N, I, H and R

Lines 2..R+1: Two distinct space-separated integers A and B (1 ≤ A, B ≤ N), indicating that cow A can see cow B.

输出格式

Lines 1..N: Line i contains the maximum possible height of cow i.

题意翻译

题目描述:

FarmerJohn 有n头牛,它们按顺序排成一列。 FarmerJohn 只知道其中最高的奶牛的序号及它的高度,其他奶牛的高度都是未知的。现在 FarmerJohn 手上有RR条信息,每条信息上有两头奶牛的序号(aa和bb),其中bb奶牛的高度一定大于等于aa奶牛的高度,且aa,bb之间的所有奶牛的高度都比aa小。现在FarmerJohnFarmerJohn想让你根据这些信息求出每一头奶牛的可能的最大的高度。(数据保证有解)

输入格式:

第1行:四个以空格分隔的整数:nn,ii,hh和RR(nn和RR意义见题面; ii 和 hh 表示第 ii 头牛的高度为 hh ,他是最高的奶牛)

接下来R行:两个不同的整数aa和bb(1 ≤ aa,bb ≤ n)

输出格式:

一共n行,表示每头奶牛的最大可能高度.

数据范围:

1 ≤ n ≤ 10000 ; 1 ≤ h ≤ 1000000 ; 0 ≤ R ≤ 10000)

Translate provided by @酥皮

输入输出样例

输入 #1复制

9 3 5 5
1 3
5 3
4 3
3 7
9 8

输出 #1复制

5
4
5
3
4
4
5
5
5

刚开始假设每头牛的身高都最高

牛序号:   1 2 3 4 5 6 7 8 9

初始身高:5 5 5 5 5 5 5 5 5 

1,3说明第1头牛的身高<=第3头牛的身高,1-3之间的第2头牛身高需要减去1

本题需要注意特殊情况,即

9 3 5 7
1 3
1 3
1 3
5 3
4 3
3 7
9 8

此时1 3中的第2头牛只需要减一次就行。所以需要对序列进行排序。

#include<iostream>
#include<cmath>
#include<algorithm>
#define N 10005
int a1[N];
using namespace std;
struct node{
	int a;
	int b;
}c[N];
bool cmp(node x, node y)//自定义排序规则,只需要对a的值从小到大排序 
{
	if(x.a <= y.a) return true;
	else return false;
}
int main()
{
	int n,i,h,R;
	cin >> n >> i >> h >> R;
	for(int i = 1; i <= n; ++i) a1[i] = h;//初始情况假设n头牛的身高都最高 
	for(int i = 1; i <= R; ++i)
	{
		cin >> c[i].a >> c[i].b;
	}
	sort(c+1,c+1+R,cmp);
	/*
	for(int i = 1; i <= R; ++i)
	{
		cout << c[i].a << " " << c[i].b << endl; 
	}
	cout << endl;
	*/
	for(int i = 1; i <= R; ++i)
	{
		if(c[i].a == c[i-1].a && c[i].b == c[i-1].b) continue;//如果和前一个区间相等,则不计算进去 
		if(c[i].a <= c[i].b)//a~b范围内的值减少1 
		{
			for(int j = c[i].a+1; j <= c[i].b-1; ++j)
			{
				a1[j]-=1;//本步骤可以使用差分进行优化
			}
		}
		else if(c[i].a > c[i].b)
		{
			for(int j = c[i].b+1; j <= c[i].a-1; ++j)
			{
				a1[j]-=1;
			}
		}
		
	}
	for(int i = 1; i <= n; ++i) cout << a1[i] << endl;
	return 0;
 } 

使用map去重 

#include<iostream>
#include<cstdio>
#include<map>
#include<algorithm>
#define N 10005
using namespace std;
map<int,int> m[N];
int a1[N];
int main()
{
	int n,i1,h,R;
	cin >> n >> i1 >> h >> R;
	int a,b;
	for(int i = 1; i <= n; ++i) a1[i] = h;
	while(R--)
	{
		cin >> a >> b;
		if(a>=b) swap(a,b);
		if(m[a][b]) continue;
		else m[a][b] = 1;
		for(int i = a+1; i <= b-1; ++i)
			a1[i] -= 1;
	}
	for(int i = 1; i <= n; ++i) cout << a1[i] << endl;
	return 0;
} 

 

使用差分和前缀和的解法,使用map去重。复杂度降低。

 

#include <stdio.h>
#include <algorithm>
#include <map>
using namespace std;
const int maxn = 100001 ;
map<int,int> mp[maxn] ;
int n,m,id,h,x,y ;
int f[maxn] ;
int main()
{
    scanf("%d%d%d%d",&n,&id,&h,&m ) ;
    for(int i=1;i<=m;i++) 
    {
        scanf("%d%d",&x,&y) ;
        if(x>y) swap(x,y) ; 
        if(mp[x][y]) continue ;
            else mp[x][y]=1 ;
        f[x+1]--;   f[y]++;//差分
    }
    for(int i=1;i<=n;i++) 
    {
        f[i] = f[i]+f[i-1] ;//前缀后得到原数组
        printf("%d\n",f[i]+h) ;
    }
    return 0;
}

 

题目描述 有一个长度为 $n$ 的书架,每本书有一个高度 $h_i$。现在你可以进行以下两种操作: - 将一本书放在书架的最左边或最右边,花费为 $c_1$。 - 将一本高度为 $h_i$ 的书放在一本高度为 $h_j$ 的书的上面,花费为 $c_2$。 现在你需要将书架上的书按照高度从小到大排列,求最小花费。 输入格式 第一行包含三个整数 $n,c_1,c_2$。 第二行包含 $n$ 个整数 $h_i$。 输出格式 输出一个整数,表示最小花费。 数据范围 $1\leq n\leq 200,1\leq c_1,c_2\leq 10^9,1\leq h_i\leq 10^9$ 输入样例 5 1 2 3 1 4 2 5 输出样例 6 算法1 (动态规划) $O(n^2)$ 首先考虑一个朴素的 dp,设 $f_{i,j}$ 表示前 $i$ 本书已经排好,第 $i+1$ 本书放在第 $j$ 个位置的最小花费。 状态转移方程为: $$ f_{i,j}=\min\{f_{i-1,k}+c_1\}+\begin{cases}&\text{if }h_{i+1}>h_j\\c_2&\text{otherwise}\end{cases} $$ 其中 $k$ 取遍 $1\sim i$,表示将第 $i+1$ 本书放在第 $k$ 个位置。 时间复杂度 $O(n^3)$ C++ 代码 算法2 (单调队列优化) $O(n^2)$ 考虑优化上述 dp,发现状态转移方程中的 $\min$ 操作可以用单调队列优化,具体来说,我们维护一个单调递增的队列 $q$,其中 $q_i$ 表示第 $i$ 个位置的最小花费,那么对于状态 $f_{i,j}$,我们只需要找到 $q$ 中第一个大于等于 $f_{i-1,k}+c_1$ 的位置 $p$,然后 $f_{i,j}=q_p+\begin{cases}&\text{if }h_{i+1}>h_j\\c_2&\text{otherwise}\end{cases}$。 时间复杂度 $O(n^2)$ C++ 代码
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值